#ifndef ADAPTIVE_METROPOLIS_HPP
#define ADAPTIVE_METROPOLIS_HPP

#include <Eigen/Dense>
#include <stan/math/prim.hpp>
#include "rng.hpp"


using namespace Eigen;
using namespace stan::math;


template<typename cov_t, typename param_t>
class AdaptiveMetropolis {
protected:
    double beta = 0.05;
    cov_t sigma_n;
    cov_t sum_sq_val;
    param_t sum_val;
    param_t mean_n;
    int dim;
    int niter = 0;

public:
    AdaptiveMetropolis() {}
    ~AdaptiveMetropolis() {}

    AdaptiveMetropolis(int dim): dim(dim) {
        niter = 0;
    }

    void init() {}

    param_t propose(param_t curr) {}

    void update_sigma(param_t curr) {}
};

#endif