#include <iostream>
#include <memory>

struct Base {
  int a;

  virtual Base* Clone() const { return nullptr; }

  virtual void set_a(int a) = 0;
  virtual int get_a() = 0;
};

struct Derived : public Base {
  virtual Derived* Clone() const override {
    std::cout << "Derived::Clone\n";
    return new Derived(*this);
  }

  void set_a(int a) override { this->a = a; }
  int get_a() override { return a; }
};

int main() {
  Base* ptr = new Derived;
  ptr->set_a(5);

  Base* ptr2 = ptr->Clone();
  ptr2->set_a(100);

  std::cout << "ptr1: " << ptr->get_a() << std::endl
            << "prt2: " << ptr2->get_a() << std::endl;
}